
import java.awt.*;
import java.awt.event.*;
import java.io.*;

import SignalLibraries.Java.graphical.Direction;
import SignalLibraries.Java.graphical.*;

public class SimuVTON_FLIGHT extends SimuC
{
    public static final int PM_INITIAL_PERIOD=4; // initial period for the pacemaker.
    public static final int DELTA = 8;
    public static final int TICK_WIDTH = 6  ;
    public static final int TICK_NUMBER = 30  ;
    public static final int TICK_HEIGHT  = 35;
    
    
    public static final int BUTTON_HEIGHT = 80;
    public static final int BUTTON_HEIGHT_PACE = 15;
    public static final int BUTTON_HEIGHT_C = 20;
    public static final int ESP_HEIGHT = 5;
    
    
    public static final int CANVAS_HEIGHT = 500 ; // 8*TICK_HEIGHT + 10*ESP_HEIGHT ;
    public static final int CANVAS_WIDTH = 700; // (DELTA+DELTA+TICK_WIDTH)*TICK_NUMBER;
    
    public static final int CANVAS_HALF_HEIGHT = 150; 
    
    public static final int LABEL_WIDTH = 170;
    public static final int BUTTON_WIDTH = 90;
    
    public static final int STRING_HEIGHT = 10 ;
    public static final int FRONT_NUMBER = 10;
    
    public static final int MIN_A = 0;
    public static final int MAX_A = 10;
    
    //    public static final int horiz=0;
    //    public static final int vertic=1;

    private int Frame, p1, p11, pm, p113;
    private int ButPlus, ButMoins, ButDiv, ButMult, ButQuit, ButAuto, ButTick, widgPm ; // paceMaker
    private int lab1, lab2, lab3, lab4, lab5, lab6, widgdisplay; // canvas
    private int slider1; // partition active id

    private paceMakerListener lpm;

    private void mkGraphicalWindows()
    {
	int vborder = BUTTON_HEIGHT/2;
	int panel;

        Frame = gw.createFrame(CANVAS_WIDTH, CANVAS_HEIGHT);
        p1 =  gw.createPanel(Frame, Direction.horiz);

        p11 = gw.createPanel(p1,Direction.vertic);

	p113 = gw.createPanelBorder(p11,Direction.horiz, vborder/2);
        lab1= gw.createLabel(p113);

	p113 = gw.createPanelBorder(p11,Direction.horiz, vborder);
        lab2 = gw.createLabel(p113);

	p113 = gw.createPanelBorder(p11,Direction.horiz, vborder);
        lab3 = gw.createLabel(p113);

	p113 = gw.createPanelBorder(p11,Direction.horiz, vborder);
        lab4 = gw.createLabel(p113);

	p113 = gw.createPanelBorder(p11,Direction.horiz, vborder);
        lab5 = gw.createLabel(p113);

	p113 = gw.createPanelBorder(p11,Direction.horiz, vborder/2);
        lab6 = gw.createLabel(p113);

	widgdisplay = gw.createCanvas(p1, CANVAS_WIDTH, CANVAS_HEIGHT , false);

	panel  = gw.createPanelBorder( Frame ,Direction.horiz, 2);
	slider1  = gw.createSlider(panel, MIN_A, MAX_A, MIN_A, 20*(MAX_A-MIN_A), 70, 1); // partition acticve id

	pm = gw.createPanelBorder(panel,Direction.horiz, 0); // PaceMaker

	widgPm = gw.createTextArea(pm, 80, 20);
	lpm = new paceMakerListener();
        ButPlus = gw.mkButtonWithoutAction(pm);
	gw.setActionTo(ButPlus, lpm);
        ButMoins = gw.mkButtonWithoutAction(pm);
	gw.setActionTo(ButMoins, lpm);
        ButDiv = gw.mkButtonWithoutAction(pm);
	gw.setActionTo(ButDiv, lpm);
        ButMult = gw.mkButtonWithoutAction(pm);
	gw.setActionTo(ButMult, lpm);
        ButAuto = gw.mkButtonWithoutAction(pm);
	gw.setActionTo(ButAuto, lpm);
        ButTick = gw.mkButtonWithoutAction(pm);
	gw.setActionTo(ButTick, lpm);
        ButQuit = gw.mkButtonWithoutAction(pm);
	gw.setActionTo(ButQuit, lpm);
    }

    // Pace maker access
    public int RCHANGE (int y) { return lpm.rcode(); }
    public boolean RUPDOWN () { return lpm.rupdown(); }
    public boolean RAUTO () { return lpm.rauto();}
    public boolean RTICK () { return lpm.rtick();}
    public boolean RSTOP () { return lpm.rstop(); }
    public void RESET_PANEL(boolean cauto)
    {
	if (cauto) 
	    {
		gw.putButtonLabel(ButAuto,"MANU");
		gw.putButtonLabel(ButQuit,"       ");
	    }
	else 
	    { 
		gw.putButtonLabel(ButAuto,"AUTO");
		gw.putButtonLabel(ButQuit,"QUIT");
	    }
    }

    // Writing/Quit
    public void WSTOP(int code) { gw.quitAppli(); }
    public void WIWRITE (int widg, int v) {  gw.setTextArea(widg, v); }
    public void WSTRING(int widg, int val, int x, int y) { gw.drawInteger(widg, val, x, CANVAS_HALF_HEIGHT-y); }

    public void WEFFACE (int widg, int x1, int dx, int dy) { gw.clearCanvas(widg, x1+1, (CANVAS_HALF_HEIGHT-dy), dx, 2*dy ); }
    public void WHLINE(int widg, int x1, int y1, int x2) { gw.drawLine(widg, x1, CANVAS_HALF_HEIGHT-y1, x2, CANVAS_HALF_HEIGHT-y1, Simu.black); }
    public void WVLINE(int widg, int x1, int y1, int y2) { gw.drawLine(widg, x1, CANVAS_HALF_HEIGHT-y1, x1, CANVAS_HALF_HEIGHT-y2, Simu.black ); }

    public int GET_DISPLAY () { return widgdisplay;};
    public int GET_PACE_WIDGET() { return widgPm; };
    public int GET_PACE_INIT () { return PM_INITIAL_PERIOD; }; 

    public int GET_ACTIVE_PARTITION () { return gw.readSlider(slider1);};
		
    public void running()
    {
	initSimu();
	while(true) iterateSignal();
    }

    public SimuVTON_FLIGHT()
    {
	mkGraphicalWindows();
	running();
    }
}

class paceMakerListener implements ActionListener
{
    public static final int LIN_CODE=2;
    public static final int EXP_CODE=1;
    public static final int NUL_CODE=0;
    
    private boolean vupdown, vauto, vstop, vtick;
    private int vcode;
    
    public paceMakerListener () 
    {
	vcode = NUL_CODE;
	vauto =  false;
	vstop = false; 
	vtick = false;
    }
    
    // Warning : The names are declared in button.txt file.
    public void actionPerformed(ActionEvent e)
    {
	String str;
	str = e.getActionCommand();
	if (str.equals("*")) { vupdown = true; 	vcode = EXP_CODE;}
	else if (str.equals("/")) { vupdown = false; vcode = EXP_CODE;}
	else if (str.equals("+")) { vupdown = true; vcode = LIN_CODE;}
	else if (str.equals("-")) { vupdown = false; vcode = LIN_CODE;}
	else if (str.equals("AUTO")) { vauto = true; vstop = false; vtick = false;}
	else if (str.equals("QUIT")) { vstop = true; }
	else if (str.equals("TICK")) { vtick = true; }
    }
    
    public int rcode() { int x; x = vcode; vcode = NUL_CODE; return x; }
    public boolean rtick() { boolean x;	x = vtick; vtick = false; return x; }
    public boolean rstop() { boolean x; x = vstop; vstop = false; return x; }
    public boolean rauto() { boolean x; x = vauto; vauto = false; return x; }
    public boolean rupdown() { return vupdown;}
}

