
/*=========================================================*/
/*        DEFINITIONS                                      */
/*=========================================================*/

#include<math.h>
#include<sys/time.h>
#include<stdio.h>

#include<X11/StringDefs.h>
#include<X11/Intrinsic.h>
#include<X11/cursorfont.h>
#include<Xm/MainW.h>
#include<Xm/Form.h>
#include<Xm/DrawingA.h>
#include<Xm/Label.h>
#include<Xm/PushB.h>
#include<Xm/Scale.h>
 
#include "type.h"
#include "common.h"
#include "random.h"
#include "esimulateur.h"
#include "interface_sig.h"

/* fichiers de l'interface graphique */
#include "panel.h"
#include "chronogramme.h"
#include "chronogramme2.h"
#include "pace_control.h"
#include "pace_rhythm.h"
#include "heure.h"

#define TBUF 256   /* taille des buffers */

extern boolean SIMULATEUR_initialize();
extern boolean SIMULATEUR_step();

/*----------------
  X11 Declarations
  ----------------*/

static MrmHierarchy Mrmdata;
static MrmType dummy_class;
XtAppContext app_context;
Widget toplevel,frame_widg,chrono_widg, pop_widg,chrono_widg_bis, pop_widg_bis;


boolean vh = pk_true;
boolean iter(boolean *vh)
{
  *vh = SIMULATEUR_step();
  return(pk_false);
}

#include "mkwindows.c"

/*-------------------------------------------------------------------*/
main()
{
  static int argc,xtnum;
  static char *argv[] = {"SIMULATOR"};
  static char adresse[TBUF];

  popup_widgT *popup_widg=XtNew(popup_widgT);
  popup_widgT *popup_widg_bis=XtNew(popup_widgT);

  MrmInitialize();
  argc = 1;
  toplevel = XtVaAppInitialize( &app_context, "SIMULATOR", NULL, 0, &argc, argv,NULL,NULL);
  mk_main_window(toplevel);
  XtRealizeWidget(toplevel);

  popup_widg->master=XtVaCreatePopupShell( "SIMULATOR", topLevelShellWidgetClass, toplevel, XmNx, 400, XmNy, 0, NULL);
  pop_widg = popup_widg->master;
  mk_curves1_window(pop_widg);
  XtRealizeWidget(pop_widg);
  XtPopup(pop_widg,XtGrabNone);


  popup_widg_bis->master=XtVaCreatePopupShell( "SIMULATOR", topLevelShellWidgetClass, toplevel, XmNx, 800, XmNy, 450, NULL);
  pop_widg_bis = popup_widg_bis->master;
  mk_curves2_window(pop_widg_bis);
  XtRealizeWidget(pop_widg_bis);
  XtPopup(pop_widg_bis,XtGrabNone);


  /*-----------------------------------
    Initializations and loop activation 
    *-----------------------------------*/
  XtAppAddWorkProc(app_context,iter,&vh); 
  SIMULATEUR_initialize();
  XtAppMainLoop(app_context);
}




