process equationSolving =
     ( ? real a;
         real b;
         real c;
       ! real x2;
         real x1;
         boolean oc;
     )
   (| (| OK := a/=0.0
       | (| SecondDegree_ABS(a,b,c) |)   / C_bb
                                         / stable
                                         / C_err
                                         / C_y
                                         / C_x
       | (| FirstDegree_ABS(not OK,b,c) |)/ C_bb
                                          / C_error
       | (| a2 := x
          | err1 := err
          | a1 := x21
          | (| u := a1 default a2
             | oc := (when err1) default err2
             |)
          | x1 := u
          |) where real u, a1, a2;
                   boolean err1; end
       | a ^= b ^= c
       |)/ err2, x, err, x21, OK |)
   where 
   boolean err2, err, C_x, C_y, C_err, stable, OK, C_error, C_bb;
     
process FirstDegree_ABS =
     ( ? boolean Compute;
         real b, c;
       ! real x;
         boolean err2, C_error, C_bb;
     )
   pragmas 
      GreyBox "FirstDegree"
   end pragmas
   (| (| Tick := true
       | when Tick ^= Compute ^= b ^= c
       | when Compute ^= C_error ^= C_bb
       | when C_error ^= err2
       | when C_bb ^= x
       |)
    | (| nlabel :: (x,err2) := FirstDegree_Cluster_1(Compute)
       | nlabel ^= when Compute
       |)
    | (| nlabel_75 :: FirstDegree_Cluster_2(Compute,c)
       | nlabel_75 ^= when Tick
       |)
    | (| nlabel_76 :: (C_error,C_bb) := FirstDegree_Cluster_3(Compute,b)
       | nlabel_76 ^= when Tick
       |)
    | (| c --> nlabel
       | b --> nlabel
       | Compute --> nlabel
       | nlabel_75 --> nlabel
       | c --> nlabel_75
       | Compute --> nlabel_75
       | nlabel_76 --> nlabel
       | b --> nlabel_76
       | Compute --> nlabel_76
       |)
    |)
   where 
   boolean Tick;
   label nlabel, nlabel_75, nlabel_76; 
   action FirstDegree_Cluster_1 =
        ( ? boolean Compute;
          ! real x;
            boolean err2;
        )
      pragmas 
         DefinedClockHierarchy
         Cluster
         BlackBox ""
      end pragmas
      external "C"
   %FirstDegree_Cluster_1%; 
   action FirstDegree_Cluster_2 =
        ( ? boolean Compute;
            real c;
        )
      pragmas 
         DefinedClockHierarchy
         Cluster
         BlackBox ""
      end pragmas
      external "C"
   %FirstDegree_Cluster_2%; 
   action FirstDegree_Cluster_3 =
        ( ? boolean Compute;
            real b;
          ! boolean C_error;
            boolean C_bb;
        )
      pragmas 
         DefinedClockHierarchy
         Cluster
         BlackBox ""
      end pragmas
      external "C"
   %FirstDegree_Cluster_3%; 
   end
%FirstDegree_ABSTRACT%; 
     
process SecondDegree_ABS =
     ( ? real a, b, c;
       ! boolean err;
         real x21, x2;
         boolean stable, C_y, C_bb, C_err, C_x;
     )
   pragmas 
      GreyBox "SecondDegree"
   end pragmas
   (| (| Tick := true
       | when Tick ^= stable ^= C_y ^= C_x
       | when stable ^= a ^= b ^= c ^= C_bb
       | when C_y ^= x2
       | when C_bb ^= C_err
       | when C_err ^= err
       | when C_x ^= x21
       |)
    | (| nlabel :: (err,x21,x2,C_y,C_err,C_x) := SecondDegree_Cluster_1()
       | nlabel ^= when Tick
       |)
    | (| nlabel_368 :: SecondDegree_Cluster_2(b)
       | nlabel_368 ^= when stable
       |)
    | (| nlabel_369 :: SecondDegree_Cluster_3(c)
       | nlabel_369 ^= when stable
       |)
    | (| nlabel_370 :: C_bb := SecondDegree_Cluster_4(a)
       | nlabel_370 ^= when Tick
       |)
    | (| nlabel_393 :: stable := SecondDegree_Cluster_delays()
       | nlabel_393 ^= when Tick
       |)
    | (| c --> nlabel
       | b --> nlabel
       | a --> nlabel
       | nlabel_368 --> nlabel
       | b --> nlabel_368
       | a --> nlabel_368
       | nlabel_369 --> nlabel
       | c --> nlabel_369
       | a --> nlabel_369
       | nlabel_370 --> nlabel_369
       | nlabel_370 --> nlabel_368
       | nlabel_370 --> nlabel
       | a --> nlabel_370
       | nlabel_370 --> nlabel_393
       | nlabel_369 --> nlabel_393
       | nlabel_368 --> nlabel_393
       | nlabel --> nlabel_393
       |)
    |)
   where 
   boolean Tick;
   label nlabel, nlabel_368, nlabel_369, nlabel_370, nlabel_393; 
   action SecondDegree_Cluster_1 =
        ( ! boolean err;
            real x21;
            real x2;
            boolean C_y;
            boolean C_err;
            boolean C_x;
        )
      pragmas 
         DefinedClockHierarchy
         Cluster
         BlackBox ""
      end pragmas
      external "C"
   %SecondDegree_Cluster_1%; 
   action SecondDegree_Cluster_2 =
        ( ? real b;
        )
      pragmas 
         DefinedClockHierarchy
         Cluster
         BlackBox ""
      end pragmas
      external "C"
   %SecondDegree_Cluster_2%; 
   action SecondDegree_Cluster_3 =
        ( ? real c;
        )
      pragmas 
         DefinedClockHierarchy
         Cluster
         BlackBox ""
      end pragmas
      external "C"
   %SecondDegree_Cluster_3%; 
   action SecondDegree_Cluster_4 =
        ( ? real a;
          ! boolean C_bb;
        )
      pragmas 
         DefinedClockHierarchy
         Cluster
         BlackBox ""
      end pragmas
      external "C"
   %SecondDegree_Cluster_4%; 
   action SecondDegree_Cluster_delays =
        ( ! boolean stable init true;
        )
      pragmas 
         DelayCluster
         Cluster
         BlackBox ""
      end pragmas
      external "C"
   %SecondDegree_Cluster_delays%; 
   end
%SecondDegree_ABSTRACT%; 

   real x21, x;
   end
; 
