process ADDINT =
     { integer NUL_CODE, LIN_CODE, TICK_NUMBER, FRONT_NUMBER, TICK_HEIGHT, DELTA, TICK_WIDTH, ESP_HEIGHT, STRING_HEIGHT, MIN_A, MAX_A, L_C, H_C, L_R, H_R, NB; }
     ( )
   (| (| X := SUM(A, B)
       | CONTEXT{}
       | SCREEN{TICK_NUMBER, FRONT_NUMBER, TICK_HEIGHT, DELTA, TICK_WIDTH, ESP_HEIGHT, STRING_HEIGHT, MIN_A, MAX_A}
       | BACK{}
       |)/ V1, HE, A, B, canvas, X |)
   where 
   use libGraphics; 
   TWindow canvas; 
   event H_0, HE; 
   process BACK =
        ( ? integer X;
          ! event HE; 
            integer V1;
        )
      (| HE := ^X
       | V1 := X
       |)
   ; 
   process CONTEXT =
        ( ! event H_0; 
            integer B; 
            integer A; 
            TWindow canvas;
        )
      (| (| PACE_MAKER{}
          | (| H := HES
             | SCAN{}
             |) where event H; end
          | createWindows{}
          | HE := true
          |)/ HE, sliderB, sliderA, frame, HES |)
      where 
      process SCAN =
           ( ? event H; 
               TWindow sliderA; 
               TWindow sliderB;
             ! integer A;
           )
         (| A := GETISIG(H, readSlider(sliderA when H))
          | B := GETISIG(H, readSlider(sliderB when H))
          |)
         where 
         process GETISIG =
              ( ? event H; 
                  integer V_ON;
                ! integer _ON_;
              )
            (| H ^= V_ON
             | _ON_ := V_ON
             |)
         ;
         end
      ; 
      process createWindows =
           ( ? TWindow frame; 
               event H_0; 
               event HE;
             ! TWindow sliderA; 
               TWindow sliderB; 
               TWindow canvas;
           )
         (| fr := frame when H_0
          | P1 := createPanel(fr, #horiz)
          | P11 := createPanel(P1, #vertic)
          | border := createBorder(P11, integer(H_C/10), integer(L_C/10))
          | L2 := createLabel(P11)
          | border2 := createBorder(P11, integer(L_C/10), 0)
          | canvas := createCanvas(P1, H_C, L_C) cell HE
          | sliderA := createSlider(fr, MIN_A, MAX_A, 0, L_R, H_R, NB) cell HE
          | L3 := createLabel(fr)
          | sliderB := createSlider(fr, MIN_A, MAX_A, 0, L_R, H_R, NB) cell HE
          | L4 := createLabel(fr)
          | border --> L2
          | P11 --> canvas
          | canvas --> sliderA
          | canvas --> sliderB
          | sliderA --> L4
          |)
         where 
         TWindow P1, P11, L1, L2, L3, L4, fr; 
         integer border, border2;
         end
      ; 
      event HES, HE; 
      TWindow frame, sliderA, sliderB;
      end
   ; 
   process SCREEN =
        { integer TICK_NUMBER, FRONT_NUMBER, TICK_HEIGHT, DELTA, TICK_WIDTH, ESP_HEIGHT, STRING_HEIGHT, MIN_A, MAX_A; }
        ( ? event HE; 
            integer V1; 
            TWindow canvas;
        )
      (| (| X := WSET{TICK_NUMBER, FRONT_NUMBER, 5*TICK_HEIGHT, DELTA+DELTA+TICK_WIDTH}(canvas, HE)
          | (| Z_V1 := V1$ init MIN_A
             | WINT{4*TICK_HEIGHT, TICK_HEIGHT, DELTA, TICK_WIDTH, 2*MIN_A, 2*MAX_A, STRING_HEIGHT}(canvas, Z_V1, V1, X)
             |)/ Z_V1
          |)/ X |)
      where 
      constant TColor vc = magenta; 
      process WSET =
           { integer XN, FN, DY, TS; }
           ( ? TWindow canvas; 
               boolean HE;
             ! integer V;
           )
         (| (| V := ACCU_MOD{TS, TS*XN, TS*(FN-1)}(HE)
             | clearCanvas(canvas when (^V), V, TS, DY)
             |)/ V
          | V := ACCU_MOD{TS, TS*XN, TS*(XN-1)}(HE)
          |)
         where 
         process ACCU_MOD =
              { integer V_INC, V_BOUND, V_INIT; }
              ( ? boolean HE;
                ! integer V;
              )
            (| V ^= HE
             | ZV := V$ init V_INIT
             | V1 := ZV+V_INC
             | V := (0 when (V1>=V_BOUND)) default V1
             |)
            where 
            integer V1, ZV;
            end
         ;
         end
      ; 
      process WBOOL =
           { integer Y_POS, BOOL_HEIGHT, DELTA, BOOL_WIDTH; }
           ( ? TWindow canvas; 
               boolean C; 
               integer X;
           )
         (| H := ^C
          | ECRAN := canvas when H
          | (| X0 := X when H
             | X1 := X0+DELTA
             | drawHorLine(ECRAN, X0, Y_POS, X1, vc)
             |)
          | (| Y2 := Y_POS+((BOOL_HEIGHT when C) default ((-BOOL_HEIGHT) when (not C)))
             | drawVertLine(ECRAN, X1, Y_POS, Y2, vc)
             | X2 := X1+BOOL_WIDTH
             | drawHorLine(ECRAN, X1, Y2, X2, vc)
             | drawVertLine(ECRAN, X2, Y_POS, Y2, vc)
             |)
          | drawHorLine(ECRAN, X2, Y_POS, X2+DELTA, vc)
          |)
         where 
         integer X0, X1, Y2, X2; 
         TWindow ECRAN; 
         event H;
         end
      ; 
      process WBOTTOM =
           { integer Y_POS, DELTA; }
           ( ? TWindow canvas; 
               event H; 
               integer X;
           )
         (| H_COMPL := [:(not H) default (^X)]
          | ECRAN := canvas when H_COMPL
          | X1 := X when H_COMPL
          | drawHorLine(ECRAN, X1, Y_POS, X1+DELTA, vc)
          |)
         where 
         integer X1; 
         TWindow ECRAN; 
         event H_COMPL;
         end
      ; 
      process WBOOLININTER =
           { integer Y_POS, BOOL_HEIGHT, DELTA, BOOL_WIDTH; }
           ( ? integer SCREEN; 
               boolean C; 
               boolean S; 
               integer X;
           )
         (| WBOTTOM{Y_POS, DELTA+DELTA+BOOL_WIDTH}(SCREEN, ^C, X)
          | WBOOL{Y_POS, BOOL_HEIGHT, DELTA, BOOL_WIDTH}(SCREEN, C, X)
          | WSTATE{Y_POS, BOOL_HEIGHT/2, DELTA+DELTA+BOOL_WIDTH}(SCREEN, S, X)
          |)
         where 
         process WSTATE =
              { integer Y_POS, BOOL_HEIGHT, DELTA; }
              ( ? TWindow canvas; 
                  boolean C; 
                  integer X;
              )
            (| H := ^C
             | ECRAN := canvas when H
             | X1 := X when H
             | X2 := X1+DELTA
             | (| Y11 := (-BOOL_HEIGHT) when C
                | Y12 := BOOL_HEIGHT when (not C)
                | Y1 := Y_POS+(Y11 default Y12)
                | drawHorLine(ECRAN, X1, Y1, X2, vc)
                |)
             | (| Y21 := Y11-1
                | Y22 := Y12+1
                | Y2 := Y_POS+(Y21 default Y22)
                | drawHorLine(ECRAN, X1, Y2, X2, vc)
                |)
             | (| Y31 := Y21-1
                | Y32 := Y22+1
                | Y3 := Y_POS+(Y31 default Y32)
                | drawHorLine(ECRAN, X1, Y3, X2, vc)
                |)
             |)
            where 
            integer X1, X2, Y11, Y12, Y1, Y21, Y22, Y2, Y31, Y32, Y3; 
            TWindow ECRAN; 
            event H;
            end
         ;
         end
      ; 
      process WINT =
           { integer Y_POS, HEIGHT, DELTA, WIDTH, C_min, C_max, STRING_HEIGHT; }
           ( ? TWindow canvas; 
               integer C_ret; 
               integer C; 
               integer X;
           )
         (| H := ^C
          | ECRAN := canvas when H
          | X0 := X when H
          | diff := C_max-C_min
          | prop := real(diff/HEIGHT)
          | C_aff := (C when ((C<C_max) when (C>C_min))) default (C_max when (not (C<C_max))) default (C_min when (not (C>C_min)))
          | Y1_rel := real(C_aff-C_min)/prop
          | Y1 := integer(Y1_rel)
          | DX := WIDTH+(2*DELTA)
          | fillRect(ECRAN, X0, Y_POS-Y1, DX, Y1, vc)
          | drawInteger(ECRAN, C_aff, X0, Y_POS+STRING_HEIGHT)
          |)
         where 
         boolean chang; 
         event H; 
         TWindow ECRAN; 
         integer X0, DX, Y1, diff, C_ret_aff, C_aff; 
         real prop, Y0_rel, Y1_rel;
         end
      ; 
      integer X, Z_V1;
      end
   ; 
   process SUM =
        ( ? integer A; 
            integer B;
          ! integer X;
        )
      (| X := A+B |)
   ; 
   integer X, B, A, V1;
   end
; 
