module AADL_DATAPORT=

use AADL_TYPE;
use AADL_PROPERTY;

process InDataPort_behavior = 
  {type item_type;}
  (? event Frozen_time_event;
     item_type write_flow;
     event clk_output;
   ! item_type read_flow;)
  pragmas
    Comment 
      "It models the behavior of an input data port of a thread."
      "The output (read_flow), produced at the clock clk_output,"
      " is a memorized value at Frozen_time_event of the input (write_flow)"
  end pragmas
  (| frozen_flow := AT(write_flow, Frozen_time_event) 
   | read_flow := AT(frozen_flow, clk_output )
   | read_flow ^= clk_output
   |) 
  where
    item_type frozen_flow;
  end;
    
process OutDataPort_behavior =
  {type item_type;}
  (? event Output_time_event;
     item_type write_flow;
   ! item_type sent_flow;)
  pragmas
    Comment 
      "It models the behavior of an output data port of a thread."
      "The ouput (sent_flow) is the lastest value of the " 
      "input (write_flow) when Output_time_event occurs"
  end pragmas
  (| sent_flow := AT(write_flow, Output_time_event) |)
  ;
     
end;
